import { Logger } from "oly-core";
import { FileService } from "./FileService";
/**
 * Provide a safe place to store files
 */
export declare class WorkspaceProvider {
    /**
     * Workspace directory.
     */
    readonly directory: string;
    /**
     * Temporary directory.
     */
    readonly tmp: string;
    /**
     * Remove workspace on start.
     */
    readonly reset: boolean;
    /**
     *
     */
    protected logger: Logger;
    /**
     *
     */
    protected file: FileService;
    /**
     * Absolute path of tmp directory.
     *
     * @return {string}
     */
    readonly tmpDirectory: string;
    /**
     * Get the absolute path of a workspace active.
     *
     * @param filename    Filename or path replace to the workspace
     */
    join(filename: string): string;
    /**
     * Generate a filepath. Useful for temp file or test.
     *
     * @return Random filepath
     */
    rand(ext?: string): string;
    /**
     *
     */
    protected onStart(): Promise<void>;
    /**
     *
     */
    protected onStop(): Promise<void>;
}
