"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var oly_core_1 = require("oly-core");
var path_1 = require("path");
var FileService_1 = require("./FileService");
/**
 * Provide a safe place to store files
 */
var WorkspaceProvider = (function () {
    function WorkspaceProvider() {
        /**
         * Workspace directory.
         */
        this.directory = path_1.join(process.cwd(), "workspace");
        /**
         * Temporary directory.
         */
        this.tmp = ".tmp";
        /**
         * Remove workspace on start.
         */
        this.reset = false;
    }
    Object.defineProperty(WorkspaceProvider.prototype, "tmpDirectory", {
        /**
         * Absolute path of tmp directory.
         *
         * @return {string}
         */
        get: function () {
            return this.join(this.tmp) + "/";
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Get the absolute path of a workspace active.
     *
     * @param filename    Filename or path replace to the workspace
     */
    WorkspaceProvider.prototype.join = function (filename) {
        if (filename[0] === "/") {
            return filename;
        }
        return path_1.resolve(this.directory, filename);
    };
    /**
     * Generate a filepath. Useful for temp file or test.
     *
     * @return Random filepath
     */
    WorkspaceProvider.prototype.rand = function (ext) {
        if (ext === void 0) { ext = ""; }
        return path_1.resolve(this.tmpDirectory, oly_core_1._.shortid() + ext);
    };
    /**
     *
     */
    WorkspaceProvider.prototype.onStart = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.reset) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.file.remove(this.directory)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [4 /*yield*/, this.file.mkdirp(this.directory)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, this.file.remove(this.tmpDirectory)];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, this.file.mkdirp(this.tmpDirectory)];
                    case 5:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     *
     */
    WorkspaceProvider.prototype.onStop = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.file.remove(this.tmpDirectory)];
                    case 1:
                        _a.sent();
                        if (!this.reset) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.file.remove(this.directory)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return WorkspaceProvider;
}());
__decorate([
    oly_core_1.env("WORKSPACE_DIRECTORY"),
    __metadata("design:type", String)
], WorkspaceProvider.prototype, "directory", void 0);
__decorate([
    oly_core_1.env("WORKSPACE_TMP"),
    __metadata("design:type", String)
], WorkspaceProvider.prototype, "tmp", void 0);
__decorate([
    oly_core_1.env("WORKSPACE_DIRECTORY_RESET"),
    __metadata("design:type", Boolean)
], WorkspaceProvider.prototype, "reset", void 0);
__decorate([
    oly_core_1.inject(oly_core_1.Logger),
    __metadata("design:type", oly_core_1.Logger)
], WorkspaceProvider.prototype, "logger", void 0);
__decorate([
    oly_core_1.inject(FileService_1.FileService),
    __metadata("design:type", FileService_1.FileService)
], WorkspaceProvider.prototype, "file", void 0);
exports.WorkspaceProvider = WorkspaceProvider;
//# sourceMappingURL=WorkspaceProvider.js.map